<?php

/*
  Plugin Name: TargetSMS.ru: СМС-рассылки и уведомления
  Description: Отправляет сообщение пользователю о смене статуса заказа.
  Author: TargetSMS
  Version: 1.0.1
 */

new TargetSMSExt;

class TargetSMSExt {
  private static $pluginName = ''; // название плагина (соответствует названию папки)
  private static $path = ''; //путь до файлов плагина 
  public function __construct() {
    mgActivateThisPlugin(__FILE__, array(__CLASS__, 'createDateBase'));
    mgAddAction(__FILE__, array(__CLASS__, 'pageSettingsPlugin'));
    mgAddAction('models_Order_sendMailOfPayed', array(__CLASS__, 'informUserSMSPaid'), 1);
    mgAddAction('models_Order_sendStatusToEmail', array(__CLASS__, 'informUserSMS'), 1);
    mgAddAction('models_order_addOrder', array(__CLASS__, 'informCreateOrderAdminSMS'), 1);
    mgAddAction('Method_confirm_sms', array(__CLASS__, 'methodConfirmSms'), 1);

    if (!URL::isSection('mg-admin')) {
      mgAddShortcode('sms', array(__CLASS__, 'sendsms'));
    }
    self::$pluginName = PM::getFolderPlugin(__FILE__);
    self::$path = PLUGIN_DIR.self::$pluginName;
  }

  /**
   * Создает таблицу настроек в БД при активации плагина
   */
  static function createDateBase() {
    DB::query("
      CREATE TABLE IF NOT EXISTS `".PREFIX."targetsms_setting` (
       `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Порядковый номер настройки',
       `option` varchar(255) NOT NULL COMMENT 'Имя опции',
       `value` longtext NOT NULL COMMENT 'Значение опции',
       `name` varchar(255) NOT NULL COMMENT 'Название опции',
       PRIMARY KEY (`id`)
      ) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 COMMENT='Настройки плагина SMS' AUTO_INCREMENT=1 ");

     DB::query("INSERT IGNORE INTO `".PREFIX."targetsms_setting` (`id`, `option`, `value`, `name`) VALUES
      (1, 'login', '', 'Ваш логин на сайте TargetSMS'),
      (2, 'pass', '', 'Ваш пароль на сайте TargetSMS'),
      (3, 'inform', 'false', 'Отправлять смс пользователю при изменении статуса заказа'),
      (4, 'log', 'false', 'Сохранять отчет в файле log_sms_send_дд.мм.г по отправленным смс'),
      (5, 'informCreateOrder', 'false', 'Отправлять смс пользователю при оформление заказа'),
      (6, 'smsLogin', 'false', 'Включить регистрацию по телефону (Отправлять коды подтверждения)'),
      (7, 'sender','targettele','Имя отправителя'),
      (8, 'admin_phone', '', 'Номер администратора')
      ");
  }

  /**
   * Получает текущий номер телефона
   */
  static function getNomer() {
    $nomer = "";
    $res = DB::query(" SELECT `value` FROM `".PREFIX."targetsms_setting` WHERE `id`= 8");
    if ($row = DB::fetchAssoc($res)) {
      $nomer = $row['value'];
    }
    return $nomer;
  }

  /**
   * Получаем данные для авторизации
   */
  static function getSecrets() {
    $settings = array();
    $res = DB::query(" SELECT `value`,`option` FROM `".PREFIX."targetsms_setting` WHERE `option`= 'login' or  `option`= 'pass'");
    
    while ($row = DB::fetchAssoc($res)) {
      $settings[$row['option']] = $row['value'];
    }
    //$settings = array('login' => 'tsms',  'pass' => '125478');

    return $settings;
  }
    /**
   * Получает значения оповещения пользователей
   */
  static function getSettings($option=false) {
    $where = '';
    $setting = array();
    if ($option) {
      $where = 'WHERE `option` = '.DB::quote($option);
    }
    $res = DB::query("SELECT `value`, `option` FROM `".PREFIX."targetsms_setting` ".$where);
    while ($row = DB::fetchAssoc($res)) {
      $setting[$row['option']] = $row['value'];
    }
    if ($option) {
      return !empty($setting[$option]) ? $setting[$option] : false;
    }
    return $setting;
  }

  /**
   * Страница настроек плагина
   */
  static function pageSettingsPlugin() {
    echo '   
      <link rel="stylesheet" href="'.SITE.'/'.self::$path.'/css/pageSettings.css" type="text/css" />  
    ';
    if (isset($_POST['login']) && isset($_POST['pass'])) {
      
      $smsLogin = $_POST['smsLogin'];
      $inform = $_POST['inform'];
      $informCreateOrder = $_POST['informCreateOrder'];
      $_POST['inform'] = (isset($_POST['inform'])?$_POST['inform']:'false');
      $_POST['informCreateOrder'] = (isset($_POST['informCreateOrder'])?$_POST['informCreateOrder']:'false');
      $_POST['log'] = (isset($_POST['log'])?$_POST['log']:'false');
      $log = $_POST['log'];
      foreach($_POST as $option => $value){
        //echo "$option $value <br>";
      DB::query("
        UPDATE `".PREFIX."targetsms_setting`
        SET `value` = ".DB::quote($value)."
        WHERE `option`='$option'
      ");
      
      }
      
     /* DB::query("
        UPDATE `".PREFIX."sms_setting`
        SET `value` = ".DB::quote($token)."
        WHERE id=2
      ");
      DB::query("
        UPDATE `".PREFIX."sms_setting`
        SET `value` = ".DB::quote($inform)."
        WHERE id=3
      ");
      DB::query("
        UPDATE `".PREFIX."sms_setting`
        SET `value` = ".DB::quote($log)."
        WHERE id=4
      ");
      DB::query("
        UPDATE `".PREFIX."sms_setting`
        SET `value` = ".DB::quote($informCreateOrder)."
        WHERE id=5
      ");
      DB::query("
        UPDATE `".PREFIX."sms_setting`
        SET `value` = ".DB::quote($smsLogin)."
        WHERE id=6
      ");*/
      
      echo "<br/><div class=\"sms-setting-update\">Данные для SMS информирования сохранены.</div>";
    } 
    $settings = self::getSettings();
      //$nomer = $settings['nomer'];
      //$token = $settings['token'];
      $smsLogin = $settings['smsLogin'];
      $inform = $settings['inform'];
      $informCreateOrder = $settings['informCreateOrder'];
      $log = $settings['log'];
    include_once('shopTargetsms.php');
    
    $auth_data = self::getSecrets();
    $targetClass = new shopTargetsms($auth_data);
    
    //self::sendsms_one('79787704278', 'Проверка могуты'); 
    $balance = $targetClass->getBalance();
    //print_r($balance);exit;
    
      echo '<div class="sms-padding">
      <style>.mg-admin-html a.site-but{padding: 7px 14px;border-radius: 8px;background: #2773eb;color: #fff;margin: 2px 10px 2px 0;text-decoration: none;}</style>
      <div class="sms-setting-block">
      <div class="row">';

    if(!isset($balance['error']))
    echo '<div class="large-6 columns" style="float: right;">
            <div class="row sett-line">
                <div class="small-12 medium-12 columns">
                    <label for="name" class="middle dashed"><b>Подключение к сервису СМС-рассылок TargetSMS.ru выполнено успешно</b></label>
                </div>
            </div>
            <div class="row sett-line">
                <div class="small-12 medium-12 columns">
                    <a href="https://sms.targetsms.ru/ru/cabinet.html" target="_blank" class="site-but">Личный кабинет</a> <a href="https://sms.targetsms.ru/ru/cabinet/pay.html" target="_blank" class="site-but">Пополнить баланс</a> 
                </div>
            </div>
            <div class="row sett-line">
                <div class="small-8 medium-4 columns">
                    <label for="name" class="middle dashed">Текущий баланс:</label>
                </div>
                <div class="small-4 medium-8 columns">
                    <span>'.$balance.' руб.</span>
                </div>
                </div>            
        </div>';
    else echo '<div class="large-6 columns" style="float: right;">
            <div class="row sett-line">
                <div class="small-12 medium-12 columns">
                    <label for="name" class="middle dashed"><b>Ошибка подключения к смс сервису</b></label>
                </div>
            </div>
        </div>';
    echo '<div class="large-6 columns">
          <form methot="post" action="" class="sms-alerts-form">
              <div class="row sett-line">
                  <div class="small-8 medium-8 columns">
                      <label for="name" class="middle dashed">Логин на сайте targetsms.ru:</label>
                  </div>
                  <div class="small-4 medium-4 columns">
                      <input class="nomer price-input" type="text" name="login" value=' . $settings['login'] . '>
                  </div>
              </div>
              <div class="row sett-line">
                  <div class="small-8 medium-8 columns">
                      <label for="name" class="middle dashed">Пароль на сайте targetsms.ru:</label>
                  </div>
                  <div class="small-4 medium-4 columns">
                      <input class="token price-input" type="password" name="pass" value=' . $settings['pass'] . '>
                  </div>
              </div>
              <div class="row sett-line">
                  <div class="small-8 medium-8 columns">
                      <label for="name" class="middle dashed">Имя отправителя:</label>
                  </div>
                  <div class="small-4 medium-4 columns">
                      <input class="token price-input" type="text" name="sender" value=' . $settings['sender'] . '>
                  </div>
              </div>
              <div class="row sett-line">
                  <div class="small-8 medium-8 columns">
                      <label for="name" class="middle dashed">Телефон администратора:</label>
                  </div>
                  <div class="small-4 medium-4 columns">
                      <input class="token price-input" type="text" name="admin_phone" value=' . $settings['admin_phone'] . '>
                  </div>
              </div>
              <div class="row sett-line">
                  <div class="small-8 medium-8 columns">
                      <label for="name" class="middle dashed">Включить регистрацию по телефону (Отправлять коды подтверждения)</label>
                  </div>
                  <div class="small-4 medium-4 columns">
                      <label class="sms-alerts-form__label">';
                  $edition = json_decode(MG::getSetting('currentVersion'), true);
                  if (($edition['edition']=='giper')) {
                    if (MG::getSetting('confirmRegistrationPhone') == 'true') {
                      echo '<input type="checkbox" name="smsLogin" value=' . $smsLogin . ' ' . ($smsLogin == 'true' ? 'checked' : '') . '>';
                    } else {
                      echo '<label for="name" class="middle dashed">
                              <span class="question__wrap" aria-label="Необходимо включить опцию Магазин-> Безопасность-> Подтверждение регистрации на сайте-> Использовать СМС подтверждения"
                              flow="leftUp" tooltip="Необходимо включить опцию Магазин-> Безопасность-> Подтверждение регистрации на сайте-> Использовать СМС подтверждения">
                                <i class="fa fa-question-circle tip" aria-hidden="true"></i>
                              </span>
                            </label>';
                    }
                  } else {
                    echo '<label for="name" class="middle dashed">
                              <span class="question__wrap" aria-label="Данная опция доступна начиная с редакции Гипермаркет"
                              flow="leftUp" tooltip="Данная опция доступна начиная с редакции Гипермаркет">
                                <i class="fa fa-question-circle tip" aria-hidden="true"></i>
                              </span>
                            </label>';
                  }
    echo '</label>
                  </div>
              </div>
              <div class="row sett-line">
                  <div class="small-8 medium-8 columns">
                      <label for="name" class="middle dashed">Информировать администратора при оформлении заказа</label>
                  </div>
                  <div class="small-4 medium-4 columns">
                      <label class="sms-alerts-form__label">
                      <input type="checkbox" name="informCreateOrder" value=' . $informCreateOrder . ' ' . ($informCreateOrder == 'true' ? 'checked' : '') . '>
                      </label>
                  </div>
              </div>
              <div class="row sett-line">
                  <div class="small-8 medium-8 columns">
                      <label for="name" class="middle dashed">Информировать пользователей при смене статуса заказа</label>
                  </div>
                  <div class="small-4 medium-4 columns">
                      <label class="sms-alerts-form__label">
                      <input type="checkbox" name="inform" value=' . $inform . ' ' . ($inform == 'true' ? 'checked' : '') . '>
                      </label>
                  </div>
              </div>
              <div class="row sett-line">
                  <div class="small-8 medium-8 columns">
                      <label for="name" class="middle dashed">Сохранять отчет в файле log_sms_send_дд.мм.г по отправленным смс</label>
                  </div>
                  <div class="small-4 medium-4 columns">
                      <label class="sms-alerts-form__label">
                      <input type="checkbox" name="log" value=' . $log . ' ' . ($log == 'true' ? 'checked' : '') . '>
                      </label>
                  </div>
              </div>
              <div class="row sett-line">
                  <div class="small-12 medium-12 columns">
                      <input type="hidden" name="pluginTitle" value="' . $_POST['pluginTitle'] . '"/>
                      <input type="submit" class="button success" value="&#xf0c7; Применить"/>
                  </div>
              </div>
          </form>
        </div>
        
      </div>  


        
      </div>
      </div>
	';
  }

  
  static function sendsms_one($phone, $text) {
    $settings = self::getSettings();
    $settings['translite'] = 0;
    include_once('shopTargetsms.php');
    $auth_data = self::getSecrets();
    $targetClass = new shopTargetsms($auth_data);
    if (isset($settings['sender']))
        $sender = $settings['sender'];
    else 
        $sender = 'targettele';
            
            
            $abonent[] = array(
                'phone' => (string)$phone,
                'number_sms' => '1'
            ); 
            $params['message'][] = array(
                 'type' => 'sms',
                 'sender' => $sender,
                 'text' => $text,
                 'name_delivery'=>'moguta_status_zakaza',
                 'translite' => $settings['translite'],
                 'abonent' => $abonent
                 );
    
            $sms = $targetClass->send_one($params);
    
    //$body = file_get_contents("http://sms.ru/sms/send?api_id=$token&to=$nomer&text=".urlencode($msg)."&partner_id=120860");
    if (self::getSettings('log')) {
      $fileName = 'log_sms_send.txt';
      $string = date('d.m.Y H:i:s').' =>'.implode(' ',$sms).'. Сообщение:'.$text.'. Получатель: '.$phone."\r\n";
      $f = fopen($fileName, 'a+');
      fwrite($f, $string);
      fclose($f);
    }
    return $body;
  }

  /**
   * Обработчик шотркода вида [sms nomer="79123456789"]Текст сообщения[/sms].
   * Отправляет СМС на указанный номер. Если номер не указан, сообщение не отправляется.

   * Если не указан текст СМС, то сообщение отправлено не будет
   */
  static function sendsms($arg) {
    $msg = $arg['content'];
    if (isset($arg['content'])) {
      $msg = $arg['content'];

      if (isset($arg['nomer'])) {
        $nomer = $arg['nomer'];
      } else {
        $nomer = self::getNomer();
      };
        $phones = explode(';',$nomer);
        foreach($phones as $phone){
            if (strlen($phone)>10)
              $res = self::sendsms_one($phone, $msg);
            }
        }
    
    return "";
  }
  /*
   * функция отправляет сообщение пользователю, если был изменен статус заказа и 
   * был отмечен чекбокс об информировании покупателя в админке
   */
  static function informUserSMS($args){
    
   /* $fileName = 'log_sms_send.txt';
      $string = date('d.m.Y H:i:s').' =>'.implode(' ',$args)."\r\n";
      $f = fopen($fileName, 'a+');
      fwrite($f, $string);
      fclose($f);*/
      
    $inform = self::getSettings('inform');// print_r($args);exit; 
    if ($inform == true) {  
      if ($args['result']) {
        $data = $args['result'];  
        $phone = preg_replace('/[^0-9]/', '', $data['orderInfo']['phone']);    
        if ($phone) {          
          ob_start();
          include ('layout_status_order.php');
          $html = ob_get_contents();
          ob_clean();
          $msg = trim($html);
          
          self::sendsms_one($phone, $msg);          
        }
      }
    }
    return $args['result'];       
  }
   /*
   * функция отправляет сообщение пользователю, при оплате заказа
   */
  static function informUserSMSPaid($args){
    $inform = self::getSettings('inform');    
    if ($inform == true) { 
      $lang = mg::get('lang');
      $data['orderInfo']['number'] = $args['args'][0];
      if (class_exists('statusOrder')) {
      $dbQuery = DB::query('SELECT `status` FROM `'.PREFIX.'mg-status-order` '
        . 'WHERE `id_status`=2');
      if ($dbRes = DB::fetchArray($dbQuery)) {
        $data['statusName'] = $dbRes['status'];
      }
    } else {
      $lang = MG::get('lang');
      $data['statusName'] = $lang['PAID'];
    }
    $dbQuery = DB::query('SELECT `phone` FROM `'.PREFIX.'order` WHERE `number`='.DB::quote($data['orderInfo']['number']));
    if ($dbRes = DB::fetchArray($dbQuery)) {
      $phone = preg_replace('/[^0-9]/', '', $dbRes['phone']);    
    }   
        if ($phone) {          
          ob_start();
          include ('layout_status_order.php');
          $html = ob_get_contents();
          ob_clean();
          $msg = trim($html);
          
          self::sendsms_one($phone, $msg);          
        }
      }    
    return $args['result'];       
  }
  
    /*
   * функция отправляет сообщение пользователю, если был изменен статус заказа и 
   * был отмечен чекбокс об информировании покупателя в админке
   */
  static function informCreateOrderAdminSMS($args){
    $informCreateOrder = self::getSettings('informCreateOrder');
    if ($informCreateOrder == true) {    
      if ($args['result']) {
        $data = $args['result'];  
        $phone = preg_replace('/[^0-9]/', '', self::getNomer());             
        if ($phone) {

          $orderInfo = DB::fetchAssoc(DB::query('SELECT * FROM `'.PREFIX.'order` WHERE `id` = '.DB::quote($data['id'])));

          include ('layout_admin_order.php');
          
          $phones = explode(';',$phone);
            foreach($phones as $admin_phone){
                self::sendsms_one($admin_phone, $msg);
            }
          //self::sendsms_one($phone, $msg);          
        }
      }
    }
    return $args['result'];       
  }
     /*
   * функция отправляет сообщение пользователю, если был изменен статус заказа и 
   * был отмечен чекбокс об информировании покупателя в админке
   */
  static function methodConfirmSms($args){
      MG::loger('methodConfirmSms');
      $smsLogin = self::getSettings('smsLogin');
      if($smsLogin == 'true' && MG::getSetting('confirmRegistrationPhone') == 'true'){
        $result = $args['result'];
        $token = self::getToken();
        $msg = 'Используйте данный код подтверждения '.$result['message']; //.' на сайте '.$_SERVER['HTTP_HOST']; //$secretSms;
        $phone = $result['phone'];

        $res = self::sendsms_one($phone, $msg);
        $status = json_decode($res);
        
        if($status->status != "ERROR"){
          $result['send'] = true; // метка состояния отправки сообщения  
        }
        //mg::loger($result['message']);    
      }
      
      return $result;
  } 
}

