<?php

class shopTargetsms {
 
  private $login;
  private $pass;
  private $security;
  
  private $url = 'https://sms.targetsms.ru/sendsmsjson.php';

  function __construct($auth_data) {
    $this->security = array('login'=>$auth_data['login'],'password'=>$auth_data['pass']);
  }

  public function send_one($post) {
    
    $resp = $this->Request('sms', $post);
    //wa_dump($resp);
    $res = array();
    if ($resp && is_array($resp)){
        foreach($resp as $result){
            $res = $result[0];
        }
    }
    if (isset($resp['error'])) {
        $res = $resp;
        $res['action']='error';
    }
    return $res;
  }

  public function send($post) {
    $request = $this->Request('sms', $post);
    return $request;
  }

  public function getStatus($ids) {
    $post['get_state'] = $ids;
    $request = $this->Request('state', $post);
    return $request;
  }

  /**
   * Получение состояния баланса
   */
  public function getBalance() {
    $res = $this->Request('balance');    
    if (isset($res['error'])){
        return $res;
    } else {
        return $res['money']['value'];
    }
  }

  /**
   * Получение списка отправителей
   */
  public function getSenders() {    
    $res = $this->Request('originator');
    
    if (isset($res['error'])){
        return $res['error'];
    } else {
        $senders = array();
        if (isset($res['list_originator'])){
            foreach($res['list_originator'] as $sender){
                if ($sender['state']=='completed')
                    $senders[] = $sender['originator'];
            }                
        }
        if (isset($res['any_originator']) && $res['any_originator']=='TRUE'){
            $senders = 'all';
        }
    }
    return $senders;
  }
    /**
   * Получение списка шаблонов
   */
  public function getPatterns() {    
    $res = $this->Request('list_patterns');
    
    if (isset($res['error'])){
        return $res['error'];
    } else {
        $patterns = array();
        if (isset($res['patterns'])){
            foreach($res['patterns'] as $pattern){
                
                    $patterns[$pattern['name']] = $pattern['pattern'];
            }                
        }
        
    }
    return $patterns;
  }

  /**
   * Отправка запроса к апи
   */

  private function Request($type, $params = array()) {
    
    $params['security'] = $this->security;
    $params['type'] = $type;
    
    $param_json = json_encode($params, true);
    $href = $this->url;
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
    curl_setopt($ch, CURLOPT_TIMEOUT, 600);
    curl_setopt($ch, CURLOPT_URL, $href);
    curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
    $res = curl_exec($ch);
    $result = json_decode($res, true);
    curl_close($ch);
    return $result;
  }



}
